



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Guava Cache 本地缓存组件浅析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Guava Cache 本地缓存组件浅析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 20:13:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>cache组件中核心的类和接口列举如下： <br />
接口：</p>
<ul><li>Cache 本地缓存的顶级接口，提供一些对缓存进行get，put的方法，以及获取缓存统计数据的方法等。</li>
<li>LoadingCache 继承了Cache接口，并另外提供了一些当get数据不存在时自动去load相关key(s)所对应的value(s)的契约（即接口中的抽象方法），具体实现见LoadingCache的具体实现类。</li>
<li>RemovalListener 监听器接口，在缓存被移除的时候用来做一些操作，与下面的RemovalNotification、RemovalCause配套使用。很明显这是个观察者模式的应用。</li>
<li>Weigher 权重的接口，提供int weigh(K key, V value)抽象方法，给缓存中的Entry赋予权重信息。</li></ul>
<p>抽象类：</p>
<ul><li>AbstractCache<br />
本身是抽象类，实现自Cache接口，基本没做什么实际的工作，大多数方法的实现只是简单抛出UnsupportedOperationException.该抽象类提供了Cache接口的骨架，为了避免子类直接继承Cache接口时必须实现所有抽象方法，这种手法在其他地方也很常见，个人觉得都算得上是一种设计模式了。</li>
<li>AbstractLoadingCache 继承自AbstractCache并实现了LoadingCache接口，目的也是提供一个骨架，其中的某些方法提供了在get不到数据时会自动Load数据的契约。</li>
<li>CacheLoader 抽象类，最核心的方法就是load，封装load数据的操作，具体如何laod与该抽象类的具体子类有关，只需要重写laod方法，就可以在get不到数据时自动去load数据到缓存中。</li>
<li>ForwardingCache<br />
装饰器模式的用法，所有对缓存的操作都委托给其他的实现了Cache接口的类，该抽象类中有一个抽象方法protected abstract<br />
Cache&lt;K, V&gt;<br />
delegate();不难推测出来，其他的方法中均使用了该代理。即类似get(key){delegate().get(key)}</li>
<li>ForwardingLoadingCache 自行推断，不解释。</li></ul>
<p>类：</p>
<ul><li>CacheBuilder 建造者模式的应用，通过该类来组装Cache，最后调用build方法来生成Cache的实例</li>
<li>CacheBuilderSpec 用来构建CacheBuilder的实例，其中提供了一些配置参数，用这些配置的参数来通过CacheBuilder实例最终构建Cache实例。</li>
<li>CacheStats 缓存使用情况统计信息，比如命中多少次，缺失多少次等等。</li>
<li>LocalCache 本地缓存最核心的类，Cache接口实例的代理人，Cache接口提供的一些方法内部均采委托给LocalCache实例来实现，LocalCache的具体实现类似于ConcurrentHashMap,也采用了分段的方式。</li>
<li><p>RemovalListeners 该类的文档中说的是A collection of common removal<br />
listeners.感觉这个类并不是这个作用，这个类提供了一个asynchronous(RemovalListener,<br />
Executor)的方法，代码如下：</p>
<pre class="prettyprint linenums"><code> public static &lt;K, V&gt; RemovalListener&lt;K, V&gt; asynchronous(<br />
  final RemovalListener&lt;K, V&gt; listener, final Executor executor) {<br />
checkNotNull(listener);<br />
checkNotNull(executor);<br />
return new RemovalListener&lt;K, V&gt;() {<br />
  @Override<br />
  public void onRemoval(final RemovalNotification&lt;K, V&gt; notification) {<br />
    executor.execute(<br />
        new Runnable() {<br />
          @Override<br />
          public void run() {<br />
            listener.onRemoval(notification);<br />
          }<br />
        });<br />
  }<br />
};<br />
}</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li></ul>
<p>看这意思是将监听器转成异步执行的，也就是在移除缓存中的数据时，用异步的方法执行onRemoval操作，在onRemoval比较耗时的时候会提升性能，不至于阻塞对缓存的其他操作。</p></li>
<li>RemovalNotification 封装了RemovalCause，典型的观察者模式。</li></ul>
<p>枚举类：</p>
<ul><li>RemovalCause 引起移除原因的枚举类，如显示调用invalidate方法产生的移除，或者是调用replace方法时产生的移除，或者是垃圾回收导致的移除，或者是缓存过期导致的移除，或者是超过了缓存大小限制导致的移除等等。</li></ul>
<p>下面列出Cache组件的特点： <br />
 -  自动加载Entry（key-value对）到缓存中 <br />
 - 当缓存超过设定的最大大小时采用LRU算法进行缓存的剔除 <br />
 - 可设定缓存过期时间，基于最后一次访问或者最后一次写入缓存两种方式 <br />
 - keys自动使用WeakReference进行包裹 <br />
 - values自动使用WeakReference或者SoftReference进行包裹 <br />
 - 当Entry从缓存中剔除时会有通知机制 <br />
 - 能够对缓存的使用情况进行统计。</p>
<p>使用示例：</p>
<pre class="prettyprint linenums"><code>LoadingCache&lt;Key, Graph&gt; graphs = CacheBuilder.newBuilder()<br />
       .maximumSize(10000)<br />
       .expireAfterWrite(10, TimeUnit.MINUTES)<br />
       .removalListener(MY_LISTENER)<br />
       .build(<br />
           new CacheLoader&lt;Key, Graph&gt;() {<br />
             public Graph load(Key key) throws AnyException {<br />
               return createExpensiveGraph(key);<br />
             }<br />
           });}</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li></ul>
<p>首先调用newBuilder静态方法产生CacheBuilder对象，然后开始装配。maximumSize(10000)表示缓存最多存放10000个键值对，超过这个数会利用LRU算法进行剔除，expireAfterWrite(10, TimeUnit.MINUTES)表示在key-value对写入缓存之后10分钟过期（过期数据不会立刻进行清除，而是在下一次进行get操作的时候判断是否过期，若过期则剔除）。removalListener(MY_LISTENER)添加监听器，在进行剔除操作的时候会调用该监听器的onRemoval方法进行操作。MY_LISTENER代表实现了RemovalListener接口的子类对象。build()方法可以传入一个CacheLoader类的子类对象，该对象用来在get数据失败时进行数据的load操作，load操作的过程就在重写的load方法中。</p>
<blockquote><p>注：如果不需要自动装载数据的功能，可以在最后的build()方法中不穿递任何参数。带不带CacheLoad类型参数的build方法代码如下所示：</p></blockquote>
<pre class="prettyprint linenums"><code>  public &lt;K1 extends K, V1 extends V&gt; Cache&lt;K1, V1&gt; build() {<br />
    checkWeightWithWeigher();<br />
    checkNonLoadingCache();<br />
    return new LocalCache.LocalManualCache&lt;K1, V1&gt;(this);<br />
  }

  public &lt;K1 extends K, V1 extends V&gt; LoadingCache&lt;K1, V1&gt; build(<br />
      CacheLoader&lt;? super K1, V1&gt; loader) {<br />
    checkWeightWithWeigher();<br />
    return new LocalCache.LocalLoadingCache&lt;K1, V1&gt;(this, loader);<br />
  }</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li></ul>
<p>可以看出来它们返回的Cache实例类型分别是LocalCache.LocalManualCache和LocalCache.LocalLoadingCache这两个静态类。再去LocalCache类里面稍微看一下这两个静态内部类的继承层次。</p>
<pre class="prettyprint linenums"><code>static class LocalManualCache&lt;K, V&gt; implements Cache&lt;K, V&gt;, Serializable

static class LocalLoadingCache&lt;K, V&gt; extends LocalManualCache&lt;K, V&gt;<br />
      implements LoadingCache&lt;K, V&gt;<br />
</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li></ul>
<p>可以看到LocalLoadingCache在继承自LocalManualCache的基础上还实现了LoadingCache接口。也就是说该类的一些方法中涉及到自动加载数据到缓存中的功能。因此构建哪种Cache完全取决于自己的需求。</p>
<p>最后需要提出的是，还可以重写CacheLoader中的loadAll（Iterable keys）方法，该方法可以用来批量加载数据，在哪种场景下需要这个方法呢？举一个例子，比如根据key获取value的操作需要经过网络连接，比较耗时，则批量导入数据则可以大大节省时间，也就是发一次网络请求获取一批数据回来。如果重写了loadAll，需要利用批量加载数据，那么就需要相应地调用Cache实例的getAll(Iterable keys)方法进行数据的批量获取，批量获取的过程中，若有一批key对应的value没有在缓存中，则会调用该loadAll方法进行批量加载。若没有重写loadAll方法，则会依次调用load方法去进行加载，因此是否需要重写loadAll方法可以看是否批量加载能大大节省时间。 <br />
使用示例如下：</p>
<pre class="prettyprint linenums"><code>LoadingCache&lt;Key, Graph&gt; loadingCache= CacheBuilder.newBuilder()<br />
       .maximumSize(10000)<br />
       .expireAfterWrite(10, TimeUnit.MINUTES)<br />
       .removalListener(MY_LISTENER)<br />
       .build(<br />
           new CacheLoader&lt;Key, Graph&gt;() {<br />
             public Graph load(Key key) throws AnyException {<br />
               return createExpensiveGraph(key);<br />
             }<br />
             public Graph loadAll(Iterable&lt;Key&gt; keys) {<br />
                 return createExpensiveGraphs(keys);<br />
             }<br />
           });}

//用法：<br />
Map&lt;Key, Graph&gt; mygraphs = loadingCache.getAll(keys);</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li></ul>
<p>若需要的数据不在缓存中或者已过期，如果重写了loadAll方法，则getAll方法内部会去调用loadAll方法加载需要的数据到缓存中，如果没有重写loadAll方法，getAll内部会依次调用load方法进行数据的加载。见如下代码：</p>
<pre class="prettyprint linenums"><code>try {<br />
          Map&lt;K, V&gt; newEntries = loadAll(keysToLoad, defaultLoader);//该laodAll方法会在defaultLoader.loadAll()方法没有进行重写时抛出异常，被下面的catch捕获。（因为默认的loadAll重写的逻辑就是是简单地抛出一个异常。）<br />
          for (K key : keysToLoad) {<br />
            V value = newEntries.get(key);<br />
            if (value == null) {<br />
              throw new InvalidCacheLoadException("loadAll failed to return a value for " + key);<br />
            }<br />
            result.put(key, value);<br />
          }<br />
        } catch (UnsupportedLoadingOperationException e) {<br />
          // loadAll not implemented, fallback to load<br />
          for (K key : keysToLoad) {<br />
            misses--; // get will count this miss<br />
            result.put(key, get(key, defaultLoader));//捕获到异常说明没有重写loadAll方法，则在get方法中会依次调用defaultLoader的load方法进行载入<br />
          }<br />
        }</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li></ul>
<p>未完待续。。。。 <br />
如有不当之处还望指正！</p></p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2gg1v8.html">DB&lowbar;oracle学习笔记&lowbar;概念分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jdrwg9.html">SSO单点登录实现原理与总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnx53q.html">javascript在html中使用 第10节</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj5pl38.html">解决Apache的错误日志巨大的问题以及关闭Apache web日志记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y7kdn8.html">使用maven搭建环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxy7jq.html">robotframework的学习笔记（十五）----robotframework标准库Collections</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1xx3jq.html">linux&lowbar;inode和block</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgmxed8.html">关于Java中equal  和 &equals;&equals;  的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kop369.html">编写简单的辅助脚本来在 Google 表格上记账</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25dj7lq.html">Java基础学习-三元运算符和键盘录入的基本步骤和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjej0r9.html">HTML XHTML HTNL5 简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4zrnx9.html">&lbrack;SQL&rsqb;SQL Server 事务及回滚事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g6pjzq.html">python中从内部循环直接跳出多层循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl2gol9.html">gem install redis安装时报错：redis requires Ruby version &amp;gt&semi;&equals; 2&period;2&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jemmjg8.html">Win32线程&mdash;&mdash;优先权</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4n0ed8.html">iOS之利用runtime，避免可变数组和可变字典为nil或者数组越界导致的崩溃</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4n25e8.html">DMA是什么意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ml3648.html">Duration Assertion（持续时间）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4pxkm8.html">python中not的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwo23nr9.html">Flask框架的学习与实战（三）：登陆管理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv14yyyq.html">Qt5和VS2017建立开发环境，安装后新建项目找不到Qt选项！！！</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6g138.html">js 压缩</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ymmyn8.html">swust oj 987</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdl0m49.html">Deployment Characteristics of &amp;quot&semi;The Edge&amp;quot&semi; in Mobile Edge Computing</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdl03z9.html">service注入失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdlzny9.html">算法与数据结构&lpar;七&rpar; AOV网的拓扑排序&lpar;Swift版&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk71vd8.html">Java 延迟队列使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljgegx9.html">&lbrack;Swift&rsqb;LeetCode792&period; 匹配子序列的单词数 &vert; Number of Matching Subsequences</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jodrl8.html">&lbrack;Swift&rsqb;LeetCode822&period; 翻转卡片游戏 &vert; Card Flipping Game</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwzn48.html">微信公众号的开发 Senparc&period;Weixin&period;dll使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
